
--默认配置
local defined = 
{     
    --动作码
    triggerType = {
      NULL          = 0,
      Blink         = 2,
      OpenMouth     = 2^2,
      ShakeHead     = 2^3,
      NodeHead      = 2^4,
      BrowJump      = 2^5,
      OK            = 2^9,
      Scissor       = 2^10,
      ThumbUp       = 2^11,
      Palm          = 2^12,
      Pistol        = 2^13,
      Love          = 2^14,
      Holdup        = 2^15,
      Congratulate  = 2^17,
      FingerHeart   = 2^18,
      IndexFinger   = 2^20,
      Fist          = 2^21,
      Six           = 2^22,
      Bless         = 2^23,
    },

    actionBaseNameIdTable = {
        ["eye_blink"] = 1,
        ["mouth_ah"] = 2,
        ["head_yaw"] = 3,
        ["head_pitch"] = 4,
        ["brow_jump"] = 5,
        ["hand_ok"] = 9,
        ["hand_scissor"] = 10,
        ["hand_good"] = 11,
        ["hand_palm"] = 12,
        ["hand_pistol"] = 13,
        ["hand_love"] = 14,
        ["hand_holdon"] = 15,
        ["hand_congratulate"] = 17,
        ["hand_finger_heart"] = 18,
        ["hand_finger_index"] = 20,
        ["hand_fist"] = 21,
        ["hand_666"] = 22,
        ["hand_bless"] = 23,
        ["background"] = 100,
        ["front"] = 101,
        ["face"] = 102,
    },

    actionBaseIdNameTable = {
        [1] = "eye_blink",
        [2] = "mouth_ah",
        [3] = "head_yaw",
        [4] = "head_pitch",
        [5] = "brow_jump",
        [9] = "hand_ok",
        [10] = "hand_scissor",
        [11] = "hand_good",
        [12] = "hand_palm",
        [13] = "hand_pistol",
        [14] = "hand_love",
        [15] = "hand_holdon",
        [17] = "hand_congratulate",
        [18] = "hand_finger_heart",
        [20] = "hand_finger_index",
        [21] = "hand_fist",
        [22] = "hand_666",
        [23] = "hand_bless",
        [100] = "background",
        [101] = "front",
        [102] = "face",
    },

    triggerTypeList = {
      ["H.eye_blink.appear"]          =  2^1,      
      ["H.mouth_ah.appear"]           =  2^2,       
      ["H.head_yaw.appear"]           =  2^3,       
      ["H.head_pitch.appear"]         =  2^4,       
      ["H.brow_jump.appear"]          =  2^5,       
      ["H.hand_ok.appear"]            =  2^9,       
      ["H.hand_scissor.appear"]       =  2^10,      
      ["H.hand_good.appear"]          =  2^11,      
      ["H.hand_palm.appear"]          =  2^12,      
      ["H.hand_pistol.appear"]        =  2^13,      
      ["H.hand_love.appear"]          =  2^14,      
      ["H.hand_holdon.appear"]        =  2^15,      
      ["H.hand_congratulate.appear"]  =  2^17,      
      ["H.hand_finger_heart.appear"]  =  2^18,
      ["H.hand_finger_index.appear"]  =  2^20,
      ["H.hand_fist.appear"]          =  2^21,
      ["H.hand_666.appear"]           =  2^22,
      ["H.hand_bless.appear"]         =  2^23,
      ["H.eye_blink.disappear"]          =  2^1 + 1,      
      ["H.mouth_ah.disappear"]           =  2^2 + 1,       
      ["H.head_yaw.disappear"]           =  2^3 + 1,       
      ["H.head_pitch.disappear"]         =  2^4 + 1,       
      ["H.brow_jump.disappear"]          =  2^5 + 1,       
      ["H.hand_ok.disappear"]            =  2^9 + 1,       
      ["H.hand_scissor.disappear"]       =  2^10 + 1,      
      ["H.hand_good.disappear"]          =  2^11 + 1,      
      ["H.hand_palm.disappear"]          =  2^12 + 1,      
      ["H.hand_pistol.disappear"]        =  2^13 + 1,      
      ["H.hand_love.disappear"]          =  2^14 + 1,      
      ["H.hand_holdon.disappear"]        =  2^15 + 1,      
      ["H.hand_congratulate.disappear"]  =  2^17 + 1,      
      ["H.hand_finger_heart.disappear"]  =  2^18 + 1,      
      ["H.hand_finger_index.disappear"]  =  2^20 + 1,
      ["H.hand_fist.disappear"]          =  2^21 + 1,
      ["H.hand_666.disappear"]           =  2^22 + 1,
      ["H.hand_bless.disappear"]         =  2^23 + 1,
    },

    --动作码触发相对应的动作
    triggerList = {
        [2^1]       = "H.eye_blink.appear",
        [2^2]       = "H.mouth_ah.appear",
        [2^3]       = "H.head_yaw.appear",
        [2^4]       = "H.head_pitch.appear",
        [2^5]       = "H.brow_jump.appear",
        [2^9]       = "H.hand_ok.appear",
        [2^10]      = "H.hand_scissor.appear",
        [2^11]      = "H.hand_good.appear",
        [2^12]      = "H.hand_palm.appear",
        [2^13]      = "H.hand_pistol.appear",
        [2^14]      = "H.hand_love.appear",
        [2^15]      = "H.hand_holdon.appear",
        [2^17]      = "H.hand_congratulate.appear",
        [2^18]      = "H.hand_finger_heart.appear",
        [2^20]      = "H.hand_finger_index.appear",
        [2^21]      = "H.hand_fist.appear",
        [2^22]      = "H.hand_666.appear",
        [2^23]      = "H.hand_bless.appear",
        [2^1 + 1]       = "H.eye_blink.disappear",
        [2^2 + 1]       = "H.mouth_ah.disappear",
        [2^3 + 1]       = "H.head_yaw.disappear",
        [2^4 + 1]       = "H.head_pitch.disappear",
        [2^5 + 1]       = "H.brow_jump.disappear",
        [2^9 + 1]       = "H.hand_ok.disappear",
        [2^10 + 1]      = "H.hand_scissor.disappear",
        [2^11 + 1]      = "H.hand_good.disappear",
        [2^12 + 1]      = "H.hand_palm.disappear",
        [2^13 + 1]      = "H.hand_pistol.disappear",
        [2^14 + 1]      = "H.hand_love.disappear",
        [2^15 + 1]      = "H.hand_holdon.disappear",
        [2^17 + 1]      = "H.hand_congratulate.disappear",
        [2^18 + 1]      = "H.hand_finger_heart.disappear",
        [2^20 + 1]      = "H.hand_finger_index.disappear",
        [2^21 + 1]      = "H.hand_fist.disappear",
        [2^22 + 1]      = "H.hand_666.disappear",
        [2^23 + 1]      = "H.hand_bless.disappear",
    },
    
    TargetStateList = {
        first_frame = "begin",
        playing = "play",
        paused = "pause",
        last_frame = "end",
        invisible = "hide",
        middle_frame = "middle"
    },

}
return defined;
